//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//// -*- c++ -*- ///////////////////////////////////////////////////
//
// $Id: compare_player.h,v 1.5 2000/10/19 15:27:56 goetz Exp $
// $Manager: holgi$
//
// compare_player.h - replay comm.log and player.log files
//                    and compare with the soccer.log file
//
// author: <holgi>
//
/////////////////////////////////////////////////////////////////////



#ifndef _COMPARE_PLAYER_H_
#define _COMPARE_PLAYER_H_

#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>

#include "worldmodel.h" // from the libMRB
#include "constants.h"
#include "coordinates.h"

#include "param.h"    // both files belong to the original
#include "types.h"    // soccer-monitor logplayer, that writes the soccer.log,
                      // perhaps replaceable with own files? 

//////////////
//
// CompPlayer class
//
//////////////

class CompPlayer {
public:
  CompPlayer():
    logfileopen(false),
    lastBallPos(Vector2d(-1000,-1000)) // invalidade lastBallPos - for first step
  {}

  int OpenFile(const char *logfilename); // open the file logfilename
                                         // returns 1 if successful, else 0
                                         // sets bool logfileopen to true if successful
  int nextSnapshot(const char *ownteamname, 
		   int callingPlayer, Snapshot &snap); // gives back the next snapshot
                                                       // returns 1 if successful, else 0
                                                       // needs the teamname of the calling player and his number
  int CloseFile(); // close logfile if exist, returns 1 if succesful, else 0
private: 
  ifstream logfile; // logfile to compare with
  bool logfileopen;
 
  int readnextShow(showinfo_t &show); // reads the next showinfo_t in the logfile
                                      // returns 1 if successful, else 0
                                      // show contains the next showinfo_t
  int ShowToSnap(const char *ownteamname, int callingPlayer, showinfo_t show, Snapshot &snap); // creates a snapshot snap out of a 
                                                   // showinfo_t show,
                                                   // ownteamname contains the teamname of the calling
                                                   // player to decide sides, callingPlayer his number to set snap.my
                                                   // returns 1 if succesful, else 0 

  int readMode();   // reads the next mode of the following information
                    // returns -1 in case of failure
                    // else 0 for no info
                    //      1 for showinfo_t
                    //      2 for msginfo_t
                    //   or 3 for drawinfo_t following in logifle
  showinfo_t readShow();  // reads next show-
  msginfo_t readMsg();    //            message-
  drawinfo_t readDraw();  //         or draw-information in the logfile
  Vector2d lastBallPos; // letzte Ballposition zur Berechnung der Geschwindigkeit ShowToSnap

}; // class CompPlayer

#endif
