//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

// -*- c++ -*- ///////////////////////////////////
//
// $Id: serverlogReader.C,v 1.5 2000/10/19 15:27:57 goetz Exp $
//
// serverlogReader.C
//
//////////////////////////////////////////////////

#include "serverlogReader.h"
#warning serverlogReader broken, compare_player has to be fixed !
ServerlogReader::ServerlogReader(const char* filename, 
				 const char* teamname, 
				 int number) {

  // initialization

  for (int i=0; i<MAX_SNAP; i++) {
    snaps[i] = NULL;
  }
  maxSnap = -1;

  // read logfile
  
  CompPlayer cp;
  int i=0;
  if (cp.OpenFile(filename)) {

    Snapshot* snap = new Snapshot();
    
    while ( cp.nextSnapshot(teamname, number, *snap) && (i<MAX_SNAP) ) {
      snaps[i] = snap;
      i++;
      snap = new Snapshot();
    }

    if (i == MAX_SNAP) {
      cerr << "ServerLog: MAX_SNAP=" << MAX_SNAP << " too small to read "
	   << "all Snapshots from file !" << endl;
      maxSnap = i-1;
    } else {
      cout << "read " << maxSnap+1 << " snapshots from " << filename << endl;
      maxSnap = i;
    }

    cp.CloseFile();

  }

}


ServerlogReader::~ServerlogReader() {
  
  for (int i=0; i<MAX_SNAP; i++) delete (snaps[i]);

}

Snapshot*
ServerlogReader::getSnapshot(int time) {
 
  if ( (time >= 0) && (time <= maxSnap))
    return snaps[time];
  else return NULL;

}
