//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

// -*- c++ -*- ///////////////////////////////////
//
// $Id: serverlogReader.h,v 1.5 2000/10/19 15:27:57 goetz Exp $
//
// serverlogReader.h
//
//////////////////////////////////////////////////

#ifndef _SERVERLOGREADER_H_
#define _SERVERLOGREADER_H_


#include "compare_player.h"
#include "worldmodel.h"

class ServerlogReader {

public:

  static const int MAX_SNAP = 8000;

  // reads data from a game's logfile and generates snapshots relative
  // to one player. maxSnap is set after generating the snaps array.
  ServerlogReader(const char* filename, // name of logfile
		  const char* teamname, // name of own team
		  int number);          // central player of the snaps
  ~ServerlogReader();
  
  // returns server snapshot for simstep <time>
  Snapshot* getSnapshot(int time);

  int getMaxTime() { return maxSnap; }

private:

  // the Snapshot store
  Snapshot* snaps [MAX_SNAP];

  // maximum index of snaps. Remaining Snapshots will be empty 
  // (ie. default constructor)
  int maxSnap;
  

};  

#endif
